package com.example;

import static org.junit.jupiter.api.Assertions.assertNotNull;

import java.io.StringReader;

import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMResult;
import javax.xml.transform.stream.StreamSource;

import org.junit.jupiter.api.Test;
import org.w3c.dom.Document;

class DefaultNsTests {

	@Test
	void testSaxonTransformToDom() throws Exception {
		TransformerFactory transformerFactory = new net.sf.saxon.TransformerFactoryImpl();
		DocumentBuilderFactory documentFactory = DocumentBuilderFactory.newDefaultInstance();
		documentFactory.setNamespaceAware(true);

		Document document = documentFactory.newDocumentBuilder().newDocument();
		DOMResult result = new DOMResult(document);

		String xml =
				  "<X xmlns=\"FOO\" xmlns:b=\"BAR\">"
				  + "<Y xmlns=\"\"/>"
				+ "</X>";

		transformerFactory.newTransformer().transform(new StreamSource(
				new StringReader(xml)), result);

		assertNotNull(document.getDocumentElement().getChildNodes().item(0)
				.getAttributes().getNamedItem("xmlns"));
	}

}
